


enum
{
	ENTITY_PLAYER,
	ENTITY_BULLET,
	ENTITY_ENEMY,
	ENTITY_OTHER
};


enum
{
	PARTICLES_EXPLOSION,
	PARTICLES_SPARKS,
	PARTICLES_SPARKS2,
	PARTICLES_IMPACT
};

enum
{
	ENEMY_FLOATER,
	ENEMY_CRAWLER,
	ENEMY_ROLLER,
	ENEMY_FIREBALL
};


#define MAX_ENTITIES 128

class CGame;

class Entity
{
public:
	VEC2 vPos;
	VEC2 vVel;
	float fRadius;
	float fAngle;

	float fRotVel;
	float fSpeed;

	bool  bAlive;
	
	int   nEntityType;

	Sprite *pSpr;

	virtual void Render() = 0;
	virtual void RenderLights(CGame *pGame) = 0;
	virtual void Update(CGame *pGame) = 0;

	virtual void HandleCollision(CGame *pGame,Entity *pEntity) {};

	
};



class Player : public Entity
{
public:
	Player(Sprite *pSpr,Sprite *pSprTurret,float fX,float fY);
	
	Sprite *pSprTurret;
	Sprite *pSprMain;

	float fThrust;

	bool bOnGround;
	int nAirborneFrames;

	void Render();
	void RenderLights(CGame *pGame);
	void Update(CGame *pGame);	
};



class Bullet : public Entity
{
public:
	Bullet(Sprite *pSpr,int nType,float fAngle,float fX,float fY, float fXV,float fYV);

	void Render();
	void RenderLights(CGame *pGame);
	void Update(CGame *pGame);	
};



class LightSource : public Entity
{
public:
	int nType;

	LightSource(Sprite *pSpr, int nType,float fX,float fY);
	void Render();
	void RenderLights(CGame *pGame);
	void Update(CGame *pGame);	

	void HandleCollision(CGame *pGame,Entity *pEntity);
};



class Enemy : public Entity
{
public:
	Enemy(Sprite *pSpr,int nType,float fX,float fY);
	
	int  nFrame;
	int  nType;
	int  nHP;
	bool bOnGround;
	float fGlow;

	void Render();
	void RenderLights(CGame *pGame);
	void Update(CGame *pGame);	
	void HandleCollision(CGame *pGame,Entity *pEntity);
};



#define MAX_PARTICLES 128

struct Particle
{
	bool  bActive;
	VEC2  vPos;
	VEC2  vVel;
	float fLife;
	float fDeath;
	float fRot;
	float fRotVel;
	float fScale;
	float fDelay;
};

class Particles : public Entity
{
public:
	Particles(Sprite *pSpr,int nCount,int nType,float fX,float fY,float fVX,float fVY);
	
	Particle p[MAX_PARTICLES];
	int  nFrame;
	int  nType;
	bool bOnGround;
	float fFlash;

	void Render();
	void RenderLights(CGame *pGame);
	void Update(CGame *pGame);		
};