#pragma once

#include <sdl.h>
#include <glheaders.h>
#include "il\il.h"		
#include "il\ilu.h"
#include "il\ilut.h"
#include "fmod.h"
#include "stdio.h"
#include "math.h"


//#define FULLSCREEN
#define WINDOWED

#define WIDTH				640
#define HEIGHT				480
#define BPP					32
#define MAX_TEXTURES		1000
#define MAX_FILENAME_LENGTH 256
#define MAX_SOUNDS			64

#define PI					(3.142f)

enum
{	
	KEY_FIRE=0,	
	KEY_UP,
	KEY_DOWN,
	KEY_LEFT,
	KEY_RIGHT,
	KEY_TLEFT,
	KEY_TRIGHT,
	KEY_QUIT,
	NUM_KEYS
};


// OpenGL-related
void GL_Viewport(int nX,int nY,int nW,int nH,bool bOrtho);
int  GL_LoadTexture(int nTex,char *szFilename);	
void GL_BindTexture(int nTex);

// Input-related
bool KEY_Pressed(int nKey);
bool KEY_State(int nKey);

// Sound related
void SFX_Load(int nId,char *szFilename);
void SFX_Play(int nId);


// Exit app?
extern bool	g_bQuit;

extern float gfGameTimer;

// Basic types
#define u8 unsigned char

struct VEC2
{
	float x;
	float y;
};



#include "glstuff.h"
#include "sprite.h"
#include "entities.h"
#include "tilemap.h"
#include "game.h"



