
// --------------------------------------------------------- 
//	LD48 #5 (I think)
//	
//	Theme: 'Light+Darkness'
//	By Dave Reed (bluescreen)
//
//	Sprite.cpp
//             
//	The now-very-familiar OpenGL sprite class. Inefficient
//  (no batching), but dead easy to use :)
// --------------------------------------------------------- 


#include "ld48.h"


void Sprite::Blit(float fX,float fY,float fRot,float fScale,int nX0,int nY0,int nW,int nH)
{
	bool bPopMatrix=false;

	// Remove any fractional component
	fX=((int)fX);
	fY=((int)fY);

	if (nW==0)
	{
		nH=this->nH;
		nW=this->nW;
	}

	// Apply xforms
	if (fScale!=1.0f || fRot!=0.0f)
	{
		bPopMatrix=true;
		glPushMatrix();
		glTranslatef(fX,fY,0);
		glScalef(fScale,fScale,1.0f);
		glRotatef((fRot/(2*PI)*360.0f),0,0,1);
		glTranslatef(-fX,-fY,0);
	}

	GL_BindTexture(nTexID);

	float fU0=((float)nX0)		* fXPixel;
	float fU1=((float)(nX0+nW)) * fXPixel;
	float fV0=((float)nY0)		* fYPixel;
	float fV1=((float)(nY0+nH)) * fYPixel;

	float fW=(float)nW;
	float fH=(float)nH;
	
	fX-=fOriginX;
	fY-=fOriginY;

	glBegin(GL_QUADS);	
	glTexCoord2f(fU0,fV0);
	glVertex3f(fX,fY,0);	
	glTexCoord2f(fU1,fV0);
	glVertex3f(fX+fW,fY,0);	
	glTexCoord2f(fU1,fV1);
	glVertex3f(fX+fW,fY+fH,0);	
	glTexCoord2f(fU0,fV1);
	glVertex3f(fX,fY+fH,0);
	glEnd();

	if (bPopMatrix) glPopMatrix();
}



void Sprite::Load(char *szFile,int nW,int nH,int nTexID)
{
	this->nTexID=nTexID;
	this->nW=nW;
	this->nH=nH;	

	GL_LoadTexture(nTexID,szFile);

	fXPixel=1.0f/((float)nW);
	fYPixel=1.0f/((float)nH);
	
	fOriginX=fOriginY=0;
}


void Sprite::SetOrigin(float fX,float fY)
{
	fOriginX=fX;
	fOriginY=fY;
}
